varying vec4 v_color;
varying vec2 v_texCoord;

uniform sampler2D u_texture;

void main() {
	vec4 textureColor = texture2D(u_texture, v_texCoord);
	gl_FragColor.rgb = (v_color.r * textureColor.rgb) + v_color.g;
	gl_FragColor.a = textureColor.a * v_color.a;
}