attribute vec4 a_position;
attribute vec4 a_color;
attribute vec2 a_texCoord;
uniform mat4 u_modelViewProjectionMatrix;

uniform vec4 u_materialAmbient;

varying vec4 v_color;
varying vec3 v_texCoord;

void main() {
	gl_Position = u_modelViewProjectionMatrix * a_position;
	v_color = a_color;
	v_texCoord.xy = a_texCoord;
	v_texCoord.z = u_materialAmbient.a;
}