package com.king.apps.pepperpanic.sound.ambient
{

    /**
     *
     */
    public class BackgroundElement
    {
        private var _baseId : String;
        private var _variations : uint;
        private var _volumeMin : Number;
        private var _volumeMax : Number;
        private var _panMin : Number;
        private var _panMax : Number;
        private var _delayRangeMin : Number;
        private var _delayRangeMax : Number;

        public function BackgroundElement(object : Object)
        {
            _baseId = object["base_id"];
            _variations = parseInt(object["variations"]);
            _volumeMin = parseFloat(object["volume_min"]);
            _volumeMax = parseFloat(object["volume_max"]);
            _panMin = parseFloat(object["pan_min"]);
            _panMax = parseFloat(object["pan_max"]);
            _delayRangeMin = parseFloat(object["delay_range_min"]);
            _delayRangeMax = parseFloat(object["delay_range_max"]);

        }

        public function getBaseId() : String
        {
            return _baseId;
        }

        public function getVariations() : uint
        {
            return _variations;
        }

        public function getVolumeMin() : Number
        {
            return _volumeMin;
        }

        public function getVolumeMax() : Number
        {
            return _volumeMax;
        }

        public function getPanMin() : Number
        {
            return _panMin;
        }

        public function getPanMax() : Number
        {
            return _panMax;
        }

        public function getDelayRangeMin() : Number
        {
            return _delayRangeMin;
        }

        public function getDelayRangeMax() : Number
        {
            return _delayRangeMax;
        }
    }
}
