
function SlideStep0()
    API_StartTutorial("blocking", "showAnimation")
    API_LoadArbitraryXML("art/scenes/animated_tutorial/tutorial_popup_match_3.xml","locatorForAnimatedTutorial")
end

function onTutorialFinished()
	if tutorialStep == 0 then
        SlideStep1()
        tutorialStep = 1
    end
end 

function SlideStep1()
	API_Log("**************step1")
	API_StartTutorial("blocking", "slideItem")
--	API_ShowTextBox("tutorial_slide_row_01")
	API_AddInputFilterArea(0, 0, 7, 9)
	API_EnableMaskTiles("false", 2, 3, 2, 4)
 	API_EnableMaskTiles("false", 1, 4, 3, 4)
--	API_HighlightItems("2,2")
	API_ShowArrowAnimation(2, 3, 2, 4)
end

function SlideStep2()
	API_Log("**************step2")
	API_StartTutorial("blocking", "slideItem")
	--API_ShowTextBox("tutorial_slide_row_01")
	API_AddInputFilterArea(0, 0, 7, 9)
	API_EnableMaskTiles("false", 4, 4, 6, 4)
	API_EnableMaskTiles("false", 5, 5, 5, 5)
--	API_HighlightItems("2,2")
	API_ShowArrowAnimation(5, 5, 5, 4)
	
end

function SlideStep3()
	API_Log("**************step3")
	API_StartTutorial("blocking", "slideItem")
--	API_ShowTextBox("tutorial_slide_column_01")
	API_AddInputFilterArea(0, 0, 7, 9)
	API_EnableMaskTiles("false", 1, 5, 1, 7)
	API_EnableMaskTiles("false", 2, 6, 2, 6)
--	API_HighlightItems("2,2")
	API_ShowArrowAnimation(2, 6, 1, 6)
	
end

function SlideStep4()
	API_Log("**************step4")
	API_StartTutorial("blocking", "slideItem")
	--API_ShowTextBox("tutorial_slide_column_01")
	API_AddInputFilterArea(0, 0, 7, 9)
	API_EnableMaskTiles("false", 6, 6, 6, 8)
	API_EnableMaskTiles("false", 5, 8, 6, 8)
--	API_HighlightItems("2,2")
	API_ShowArrowAnimation(5, 8, 6, 8)
	
end

function ShowYouHaveDoneGreat()
	API_Log("**************step5")

--	API_StartTutorial("blocking", "anyTouch")
	API_EnableGlobalMasking("false")
--  API_ShowTextBox("tutorial_congratulation")
--	API_SetAllowedSliding("all")
	API_EnableHint("true")
	API_EndTutorial()
end


function onInit()
	API_EnableHint("false")
	API_Log("**************onInit TUTORIAL")
	API_Log("**************BOARD NUM_TILES_X:" .. NUM_TILES_X)
	API_Log("**************BOARD NUM_TILES_Y:" .. NUM_TILES_Y)
	SlideStep0()
	tutorialStep = 0
	EXPECTED_MATCH_STEP_1 = {33,34,35}
	EXPECTED_MATCH_STEP_2 = {36,37,38}
	EXPECTED_MATCH_STEP_3 = {41,49,57}
	EXPECTED_MATCH_STEP_4 = {55,62,70}
	continue = true
	onMatchProcess = true
	API_Log(table.tostring(EXPECTED_MATCH_STEP_1))
	API_Log(table.tostring(EXPECTED_MATCH_STEP_2))
	API_Log(table.tostring(EXPECTED_MATCH_STEP_3))
	API_Log(table.tostring(EXPECTED_MATCH_STEP_4))
	--API_AddItemsToSpawnerBuffer("normal:blue,normal:yellow,normal:red,normal:red,normal:yellow,normal:blue,normal:orange,normal:red,normal:pink");
end


function onEndTurn()
	API_Log("**************onEndTurn (tutorialStep = " .. tutorialStep .. ")")
	if continue == true then
		onMatchProcess = true
		if tutorialStep == 1 then
			API_Log("**************Going to SlideStep2")
			SlideStep2()
			tutorialStep = 2
		elseif tutorialStep == 2 then
			API_Log("**************Going to SlideStep3")
			tutorialStep = 3
			SlideStep3()
		elseif tutorialStep == 3 then
			API_Log("**************Going to SlideStep4")
			tutorialStep = 4
			SlideStep4()
		elseif tutorialStep == 4 then
			API_Log("**************Going to SlideStep5")
			tutorialStep = 5
			ShowYouHaveDoneGreat()
		end
	end
end

function onMatch(matchTiles)
	if continue == true and onMatchProcess == true then
		tiles = {}
		API_Log("**************onMatch (tutorialStep = ".. tutorialStep .. ") Matching tiles:" .. matchTiles)
		tiles = getTilesFromMatchString(matchTiles)
		API_Log("************** Going to compare...")
		API_Log("************ TABLE tiles:" .. table.tostring(tiles))
		if tutorialStep == 1 then
			API_Log("************ TABLE EXPECTED_MATCH_STEP_1:"  .. table.tostring(EXPECTED_MATCH_STEP_1))
			continue = IsExpectedMatch(EXPECTED_MATCH_STEP_1, tiles)
		elseif tutorialStep == 2 then
			API_Log("************ TABLE EXPECTED_MATCH_STEP_2:"  .. table.tostring(EXPECTED_MATCH_STEP_2))
			continue = IsExpectedMatch(EXPECTED_MATCH_STEP_2, tiles)
		elseif tutorialStep == 3 then
			API_Log("************ TABLE EXPECTED_MATCH_STEP_3:"  .. table.tostring(EXPECTED_MATCH_STEP_3))
			continue = IsExpectedMatch(EXPECTED_MATCH_STEP_3, tiles)
		elseif tutorialStep == 4 then
			API_Log("************ TABLE EXPECTED_MATCH_STEP_4:"  .. table.tostring(EXPECTED_MATCH_STEP_4))
			continue = IsExpectedMatch(EXPECTED_MATCH_STEP_4, tiles)
		end
		if (continue == true) then
			API_Log("************ continue !!!")
			onMatchProcess = false
		else
			API_Log("************ NO continue !!!")
			API_EnableHint("true")
		end
		if tutorialStep < 6 then
			API_EndTutorial()
		end
	end
end

function getTilesFromMatchString(matchingTiles)
	tilesFromMatch = {}
	for tileIndex in matchingTiles:gmatch("([%d%.%+%-]+),?") do
		tilesFromMatch[#tilesFromMatch + 1] = tonumber(tileIndex)
	end
	return tilesFromMatch;
end

function IsExpectedMatch(expectedMatch, matchReceived)
	return equals(expectedMatch, matchReceived, false);
end