
function SlideStep0()
    API_StartTutorial("blocking", "showAnimation")
    API_LoadArbitraryXML("art/scenes/animated_tutorial/tutorial_popup_seeding.xml","locatorForAnimatedTutorial")
end

function onTutorialFinished()
	if tutorialStep == 0 then
        SlideStep1()
        tutorialStep = 1
    end
end 

function SlideStep1()
	API_Log("**************step1")
	API_StartTutorial("blocking", "slideItem")
--	API_ShowTextBox("tutorial_slide_row_01")
	API_AddInputFilterArea(0, 0, 7, 9)
	API_EnableMaskTiles("false", 2, 4, 3, 4)
 	API_EnableMaskTiles("false", 3, 3, 3, 5)
--	API_HighlightItems("2,2")
	API_ShowArrowAnimation(2, 4, 3, 4)
end

function ShowYouHaveDoneGreat()
	API_Log("**************step5")

--	API_StartTutorial("blocking", "anyTouch")
	API_EnableGlobalMasking("false")
--  API_ShowTextBox("tutorial_congratulation")
--	API_SetAllowedSliding("all")
	API_EnableHint("true")
	API_EndTutorial()
end


function onInit()
	API_EnableHint("false")
	API_Log("**************onInit TUTORIAL")
	API_Log("**************BOARD NUM_TILES_X:" .. NUM_TILES_X)
	API_Log("**************BOARD NUM_TILES_Y:" .. NUM_TILES_Y)
	SlideStep0()
	tutorialStep = 0
	EXPECTED_MATCH_STEP_1 = {27,35,43}
	continue = true
	onMatchProcess = true
	API_Log(table.tostring(EXPECTED_MATCH_STEP_1))
	--API_AddItemsToSpawnerBuffer("normal:blue,normal:yellow,normal:red,normal:red,normal:yellow,normal:blue,normal:orange,normal:red,normal:pink");
end


function onEndTurn()
	API_Log("**************onEndTurn (tutorialStep = " .. tutorialStep .. ")")
	if continue == true then
		onMatchProcess = true
		if tutorialStep == 1 then
			API_Log("**************Going to SlideStep2")
			SlideStep2()
			tutorialStep = 2
		end
	end
end

function onMatch(matchTiles)
	if continue == true and onMatchProcess == true then
		tiles = {}
		API_Log("**************onMatch (tutorialStep = ".. tutorialStep .. ") Matching tiles:" .. matchTiles)
		tiles = getTilesFromMatchString(matchTiles)
		API_Log("************** Going to compare...")
		API_Log("************ TABLE tiles:" .. table.tostring(tiles))
		if tutorialStep == 1 then
			API_Log("************ TABLE EXPECTED_MATCH_STEP_1:"  .. table.tostring(EXPECTED_MATCH_STEP_1))
			continue = IsExpectedMatch(EXPECTED_MATCH_STEP_1, tiles)
		end
		if (continue == true) then
			API_Log("************ continue !!!")
			onMatchProcess = false
		else
			API_Log("************ NO continue !!!")
			API_EnableHint("true")
		end
		if tutorialStep < 6 then
			API_EndTutorial()
		end
	end
end

function getTilesFromMatchString(matchingTiles)
	tilesFromMatch = {}
	for tileIndex in matchingTiles:gmatch("([%d%.%+%-]+),?") do
		tilesFromMatch[#tilesFromMatch + 1] = tonumber(tileIndex)
	end
	return tilesFromMatch;
end

function IsExpectedMatch(expectedMatch, matchReceived)
	return equals(expectedMatch, matchReceived, false);
end


