package com.king.apps.pepperpanic.sound.ambient
{
    /**
     *
     */
    public class AmbientSoundSetEntry
    {
        private var _ambientSetId:String;
        private var _ambientLoopSound:AmbientLoopSound;
        private var _backgroundElements:Vector.<BackgroundElement>;

        public function AmbientSoundSetEntry(entryJson:Object)
        {
            _ambientSetId = entryJson["ambient_set_id"];
            _ambientLoopSound = new AmbientLoopSound(entryJson["ambient_loop_sound"]);
            _backgroundElements = new Vector.<BackgroundElement>();

            for each(var object:Object in entryJson["background_elements"])
            {
                _backgroundElements.push(new BackgroundElement(object));
            }
        }

        public function getAmbientSetId() : String
        {
            return _ambientSetId;
        }

        public function getAmbientLoopSound() : AmbientLoopSound
        {
            return _ambientLoopSound;
        }

        public function getBackgroundElements() : Vector.<BackgroundElement>
        {
            return _backgroundElements;
        }
    }
}
