package com.king.apps.pepperpanic.sound.ambient
{
    public class SwitcherAmbientBackgroundSoundSetMapping
    {
        private static const EPISODE_TO_SET : Object = {
            "1": 1,
            "2": 2,
            "3": 3,
            "4": 4,
            "5": 2,
            "6": 3,
            "7": 7,
            "8": 8,
            "9": 9,
            "10": 10,
            "11": 11,
            "12": 12,
            "13": 2,
            "14": 4,
            "15": 4,
            "16": 4,
            "17": 12,
            "18": 18,
			"19": 19,
            "20": 7,
            "21": 21,
            "22": 22,
            "23": 23,
            "24": 24,
            "25": 2,
            "26": 26,
            "27": 27,
            "28": 28,
            "29": 29,
            "30": 30,
            "31": 28
        };
        public static function getSoundSetIdForEpisodeId(episodeId : uint) : uint
        {
            var episodeIdAsString : String = String(episodeId);
            if(EPISODE_TO_SET.hasOwnProperty(episodeIdAsString))
            {
                return EPISODE_TO_SET[episodeIdAsString];
            }
            else
            {
               throw new Error("Ambient sound set for episode " + episodeId + " is not defined");
            }
        }
    }
}
